package com.link.base.basic.controller;

import com.link.base.basic.model.BasicLog;
import com.link.base.basic.service.BasicLogService;
import com.link.core.basic.model.BasicModel;
import com.link.core.basic.query.QueryParams;
import com.link.core.basic.service.BasicService;
import com.link.core.modules.export.ExportFactory;
import com.link.core.modules.export.ExportWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/link/basicLog"})
public class PortalBasicLogController {
   @Resource
   private BasicLogService basicLogService;
   private static final Logger logger = LogManager.getLogger(PortalBasicLogController.class);

   public BasicService<BasicLog> getBasicService() throws Exception {
      return this.basicLogService;
   }

   @RequestMapping({"/queryByExamplePage"})
   @ResponseBody
   public Map<String, Object> queryByExamplePage(QueryParams qps, BasicLog record, HttpSession session, HttpServletRequest request, HttpServletResponse response) {
      Map<String, Object> result = new HashMap();

      try {
         qps.invokePreFilterAndSorter();
         BasicLog basicLog = (BasicLog)BasicModel.transformClass(record.getClass(), qps);
         List<BasicLog> list = this.getBasicService().queryByExamplePage(basicLog);
         result.put("success", true);
         result.put("rows", list);
         result.put("total", getCount(basicLog, list.size()));
      } catch (Exception var9) {
         Exception e = var9;
         logger.error("PortalBasicLogController捕获异常: ", e);
         result.put("success", false);
         result.put("rows", new ArrayList());
         result.put("result", e.getMessage());
      }

      return result;
   }

   @RequestMapping({"/queryByExamplePage/exportData"})
   @ResponseBody
   public Map<String, Object> exportData(BasicLog entity, QueryParams qps, HttpSession session, HttpServletRequest request, HttpServletResponse response) {
      Map<String, Object> result = new HashMap();

      try {
         qps.preDealSecurity(request);
         ExportWriter exportWriter = ExportFactory.newInstance(qps);
         BasicLog basicLog = (BasicLog)BasicModel.transformClass(entity.getClass(), qps);

         while(!qps.getStopExport()) {
            basicLog = (BasicLog)BasicModel.transformClass(entity.getClass(), qps);
            exportWriter.wirteData(this.getBasicService().queryByExamplePage(basicLog));
         }

         result.put("success", true);
         result.put("url", exportWriter.getUrlPath());
         result.put("total", basicLog.getTotal());
      } catch (Exception var9) {
         Exception e = var9;
         logger.error("PortalBasicLogController捕获异常: ", e);
         result.put("success", false);
         result.put("result", e.getMessage());
      }

      return result;
   }

   public static Integer getCount(BasicLog basicModel, int len) {
      int startRow = basicModel.getStartRow();
      int rows = basicModel.getRows();
      if (len < rows) {
         return startRow + len - 1;
      } else {
         return rows == len ? startRow * basicModel.getPage() + rows : basicModel.getTotal();
      }
   }
}
